#include <atlbase.h>
#include <atlapp.h>
extern "C" CComModule _Module;
#include <atlmisc.h>
#include <windowsx.h>
#include "HookHlpr.h"

class CData : public CHookBaseData
{
public:
	CData( int nHookType )
	{
		m_nHookType = nHookType;
	}

	HWND m_hLogWnd;

	void SetData( HWND hEdit )
	{
		m_hLogWnd     = hEdit;
		m_hHook       = NULL;
		//m_nHookType   = WH_SYSMSGFILTER;
	}
};

interface IHookDriver : IUnknown
{
	STDMETHOD(Set)(long, long) PURE;
	STDMETHOD(Free)() PURE;
	STDMETHOD(SetHwnd)(long) PURE;
};

// ,       COM-
class CHookSysMsgFilter :  public IHookDriver,
                           public CHookBaseT<CHookSysMsgFilter, CData>
{
public:
	CHookSysMsgFilter( CData* pData )
			: CHookBaseT<CHookSysMsgFilter, CData>(pData)
	{
		Init();
	}

	void GetModuleFileName()
	{
		TCHAR buf[MAX_PATH];
		::GetModuleFileName( GetModuleHandle(NULL), buf, sizeof(buf) );
		m_pszModuleFileName = buf;
	}
	
	void Log( LPCTSTR pszRecord )
	{
		HWND hEdit = m_pData->m_hLogWnd;
		Edit_SetSel( hEdit, -1, -1 );
		Edit_ReplaceSel( hEdit, pszRecord );
	}

	LRESULT HookProc( int code, WPARAM wParam, LPARAM lParam )
	{
		LPMSG pMsg  = (LPMSG)lParam;

		switch( code )
		{
		case MSGF_MENU:
			{
				if( WM_MENUSELECT == pMsg->message )
				{
					GetModuleFileName();
					CString s;
					s.Format( _T("\r\n%s\r\n"), m_pszModuleFileName );
					Log( s );
					s.Format( _T("code\t%d\r\nwParam\t%d\r\n")
						      _T("lParam\t%d\r\nhHook\t%d\r\n"),
						code, wParam, lParam, GetHookHandle() );
					Log( s );
					
					if( 0 == lParam )
						break;

					HMENU hMenu = (HMENU)pMsg->lParam;
					MENUITEMINFO mii = {0};
					mii.cbSize = sizeof(mii);
					mii.fMask  = MIIM_FTYPE | MIIM_ID | MIIM_STRING | MIIM_STATE;
					
					//   mii.dwTypeData ,     
					GetMenuItemInfo(  hMenu, LOWORD(pMsg->wParam), FALSE, &mii );
					{
						//  mii.cch     
						if( (MFT_STRING == mii.fType) && mii.cch )
						{
							mii.cch++;	//    
							mii.dwTypeData = (char*)LocalAlloc(GPTR, mii.cch);
						}
						else
							break;
					}
					
					if(mii.dwTypeData)
						*mii.dwTypeData = '\0';
					else
						break;

					if( GetMenuItemInfo( hMenu, LOWORD(pMsg->wParam), 
						                 FALSE, &mii ) )
					{
						//     
						//  "Close" (   "")
						if( SC_CLOSE == mii.wID )
						{
							_tcsrev(mii.dwTypeData); //    :)
							SetLastError(0);
							ModifyMenu( hMenu, SC_CLOSE, 
										MF_BYCOMMAND |
										( mii.fState & MFS_CHECKED ? 
                                          MF_UNCHECKED : MF_CHECKED ), 
										SC_CLOSE, mii.dwTypeData );
							{
								s.Format( _T("ModifyMenu: %08X\r\n"), 
									      GetLastError() );
								Log(s);
							}
						}
						s.Format( _T("Menu:\t%s\r\n"), mii.dwTypeData );
						Log( s );
					}
					if(mii.dwTypeData)
						LocalFree(mii.dwTypeData);
					return TRUE;
				}
			}
			break;
		}
		return FALSE;
	}

	STDMETHOD(QueryInterface)(REFIID,void**)
	{
		return E_NOTIMPL;
	}
	
	STDMETHOD_( ULONG, AddRef )()
	{
		return 0;
	}

	STDMETHOD_( ULONG, Release )()
	{
		return 0;
	}
	
	STDMETHOD(Set)(long lInst, long lThreadId)
	{
		if( SetHook( (HINSTANCE)lInst, (DWORD)lThreadId ) )
			return S_OK;
		else
			return E_FAIL;
	}

	STDMETHOD(Free)()
	{
		Unhook();
		return S_OK;
	}

	STDMETHOD(SetHwnd)(long lWnd)
	{
		m_pData->m_hLogWnd = (HWND)lWnd;
		return S_OK;
	}

protected:
	CString m_pszModuleFileName;
};
