#include <windows.h>
#include <tchar.h>
#include "HkEdDlg.h"
#include "resource.h"
#include "HookHlpr.h"

#define WM_ABOUTBOX  WM_APP + 200  //    
                                   //    

//     (   dll)
DECLARE_HOOK_DLL( WH_SYSMSGFILTER )

//    
DECLARE_LOCAL_HOOK( WH_MSGFILTER, DlgBoxMsgFilter )

// , , ,   ,   
//   ,  
static HWND g_hDlg = NULL;

LRESULT DlgBoxMsgFilter( UINT code, WPARAM wParam, LPARAM lParam )
{
	LPMSG pMsg   = (LPMSG)lParam;
	HWND  hEdit1 = GetDlgItem( g_hDlg, IDC_EDIT1 ), 
		  hEdit2 = GetDlgItem( g_hDlg, IDC_EDIT2 );

	switch( code )
	{	
	case MSGF_DIALOGBOX:
		{
			//      
			if( hEdit1 != pMsg->hwnd && hEdit2 != pMsg->hwnd )
				return FALSE;

			switch(pMsg->message)
			{
			case WM_KEYDOWN:
				if( VK_RETURN == pMsg->wParam )
				{
					//  Enter,      ()
					SendMessage( g_hDlg, pMsg->message, pMsg->wParam, pMsg->lParam );
					
					//    TABSTOP- 
					SetFocus( GetNextDlgTabItem( g_hDlg, pMsg->hwnd, FALSE ) );
					return TRUE;
				}
				break;
			}
		}
		break;
	}
	return FALSE;
}

//    dll    
//      exe-
BOOL ExtractLibFromRes( LPCTSTR szLib, LPCTSTR szResType )
{
	HINSTANCE hLib      = NULL;
	BOOL      res       = FALSE;
	TCHAR     szName[MAX_PATH] = {0};
	LPTSTR    pszName   = NULL;
	HRSRC     hRes      = NULL;
	HGLOBAL   hMem      = NULL;
	DWORD     dwSize    = 0;
	LPVOID    pLib      = NULL;
	HANDLE    hLibFile  = NULL;
	DWORD     dwWritten = 0;

	// -       dll,
	// ,      , 
	//   
	if( hLib = LoadLibrary( szLib ) )
	{
		FreeLibrary( hLib );
		return TRUE;
	}
	
	GetModuleFileName( GetModuleHandle(NULL), szName, MAX_PATH );
	pszName = _tcsrchr( szName, _T('\\') );
	if( pszName )
		lstrcpy( pszName + 1, szLib );
	else
		lstrcpy( szName, szLib );
	
	__try
	{
		if( NULL == (hRes   = FindResource( NULL, szLib, szResType )) ||
		    NULL == (hMem   = LoadResource( NULL, hRes )            ) ||
		    0    == (dwSize = SizeofResource( NULL, hRes )          ) ||
		    NULL == (pLib   = LockResource( hMem )                  ) ||
			INVALID_HANDLE_VALUE == (hLibFile = CreateFile( 
													szName, GENERIC_WRITE, 
													0, NULL, CREATE_ALWAYS, 
													0, NULL )       )
		  )
			__leave;
		res = WriteFile( hLibFile, pLib, dwSize, &dwWritten, NULL );
	}
	__finally
	{
		CloseHandle( hLibFile );
		FreeResource( hMem );		
	}
	return res;
}

BOOL CALLBACK DlgProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
    static char m_edText[256] = "";

    switch( msg )
    {
    case WM_INITDIALOG:
		g_hDlg = hDlg;
		
		SendMessage( hDlg, WM_SETICON, ICON_BIG,
			(LPARAM)LoadIcon(NULL, IDI_INFORMATION) );
		
		if( ExtractLibFromRes( _T("SysHkLib.dll"), _T("HOOKLIB") ) )
		{
			//  dll    
			LOAD_HOOK_DLL( WH_SYSMSGFILTER, _T("SysHkLib.dll") )
		}

		//   
		SET_LOCAL_HOOK( WH_MSGFILTER )
        break;

    case WM_COMMAND:
        if(wParam == IDCANCEL || wParam == IDOK)
		{
			//   
			UNHOOK_LOCAL_HOOK( WH_MSGFILTER )

			//      dll
			UNLOAD_HOOK_DLL( WH_SYSMSGFILTER )
			EndDialog(hDlg, 0);
		}
		break;

	case WM_SYSCOMMAND:
		if( wParam == WM_ABOUTBOX )
		{
			//       :)
			char szText[128];
			GetWindowText( hDlg, szText, sizeof(szText) );
			lstrcat( szText, _T("\n2001(c) Igor Vartanov") );
			MessageBox(hDlg, szText, _T("About..."), MB_OK);
		}
        break;

    case WM_KEYDOWN:
		//       
        if( VK_RETURN == wParam) 
		{
			GetDlgItemText( hDlg, IDC_EDIT1, m_edText, 256 );
			SetDlgItemText( hDlg, IDC_EDIT2, m_edText );
		}
        break;

	case WM_INITMENUPOPUP:
		{
			static bAppended = FALSE;
			HMENU hMenu = (HMENU)wParam;
			if( !bAppended )
			{
				//       :)
				AppendMenu( hMenu, MF_STRING, WM_ABOUTBOX, _T("About...") );
				bAppended = TRUE;
			}
		}
		break;
    }
    return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    DialogBox(hInstance, _T("MAINDLG"), HWND_DESKTOP, (DLGPROC)DlgProc);
    return 0;
}
